using System;
using System.Collections;
using System.IO;
/*
* do an `export QUERY_STRING=foo\=baz\&` before testing this program
*/
namespace WebSharp
{
	public class Dictionary
	//had to write a Dictionary just to work things out
	{
		private ArrayList keys;
		private ArrayList values;
		public int Count;
		//see I'm too lazy to complete the hashtable
		public Dictionary()
		{
			keys=new ArrayList();
			values=new ArrayList();
			Count=0;
		}
		public void Add(Object key,Object value)
		//after full impl will Interface IDictionary
		{
			try
			{
				int index=keys.IndexOf(key);
				values[index]=value;
			}
			catch(ArgumentException)
			{
				keys.Add(key);
				Count=Count+1;
				values.Add(value);
			}
		}
	 	public void Remove(Object key)
		{
			int index=keys.IndexOf(key);
			if(index==-1)
				{
					throw new ArgumentException("Argument not found");
					//throw new ArgumentException(_("Arg_NotFound"));
					//hope this works with CSCC, nope it doesn't
				}
			keys.RemoveAt(index);
			values.RemoveAt(index);
		}
		public Object Get(String key)
		{
			int index;
			try
			{
				index=keys.IndexOf(key);
			}
			catch(Exception)
			{
				throw;
			}
			return values[index];
		}
		public Object this[String key1]
		{
			get
			{
				return Get(key1);
			}
			set
			{
				Add(key1,value);	
			}
		}
		public String ToString()
		{
			String retval="";
			for(int i=1;i<keys.Count;i++)
			{
				retval=retval+(String) keys[i]+" => "+(String)
				values[i]+" \n";
			}
			return retval;
		}
		public void Clear()
		{
			keys.Clear();
			values.Clear();
			Count=0;
		}
		public ArrayList Keys()
		{
			return keys;
		}
		public ArrayList Values()
		{
			return values;
		}
		public bool Contains(Object key)
		{
			try
			{
				int i=keys.IndexOf(key);
				if(i==-1)return false;
				return true;
			}
			catch(ArgumentOutOfRangeException)
			{
				return false;
			}
			return false;
		}
	};



/*
 * Start the WEB specific parts.
 * Man !
 */
	public class WebRequest
	{
		public IDictionary EnvVars;
		public Dictionary QueryParsed;
		public WebRequest ()
		{
			QueryParsed=new Dictionary();
		}
		public void ReadRequest ()
		{
			this.EnvVars = Environment.GetEnvironmentVariables ();
			if (EnvVars["QUERY_STRING"] != null)
			{
				String queryString = (String) EnvVars["QUERY_STRING"];
				this.ParseQuery (queryString);
			}
		}
		public void PutQueryVar(String pair)
		{
			if (pair.IndexOf ("=") != -1)
				{
					String key = pair.Substring (0, pair.IndexOf ("="));
					String val = pair.Substring (pair.IndexOf ("=") + 1);
					//Console.WriteLine (key + " => " + val);
					// I wish I had  a Hashtable to put it into
					// but anyway my Dictionary will do.....
					QueryParsed.Add(key,val);
					//Console.WriteLine(QueryParsed.Count+":"+key+" ==> "+ val);
					//must implement multiple keys later..someday
				}
			else
				{
					//should throw an exception
				}
		}
		public void ParseQuery (String queryString)
		{
			int end = 0, j = 0;
			bool processed = false;
			//the query string gets destroyed into a
			//set of parsed values
			//no problem about that
			while (queryString.IndexOf ("&") != -1
			&& queryString.IndexOf ("=") != -1)
			{
				end = queryString.IndexOf ("&");
				String pair = queryString.Substring (0, end);
				PutQueryVar(pair);
				if (end < queryString.Length)end++;
				queryString = queryString.Substring (end);
				processed = true;
			}
			//but some browsers sumbit single values as
			//?query=ok 
			//without the & at the end;there fore
			if (queryString.IndexOf("&")==-1 && queryString.IndexOf("=")!=-1)
			{
				if (queryString.IndexOf ("=") != -1)
				{
					PutQueryVar(queryString);
				}
				//PutQueryVar(dat);
			}
		}
		public String GetEnvVars (String key)
		{
			return (String) this.EnvVars[key];
		}
	};//class
	
	public class WebResponse
	{
		private WebRequest req;
		int header_status;
		public WebResponse()
		{
			header_status=0;
		}
		//seems like my Java is bubbling up again !
		//for the get set pairs.......:-)
		public void SetRequest(WebRequest req)
		{
			this.req=req;
		}
		public void HeaderStart()
		{
			header_status=1;
		}
		public void Header(String name,String value)
		{
			if(header_status==1)
			{
				Console.Write(name+": "+value+"\r\n");
			}
			else if(header_status==0)
			{
				throw new Exception("Header unstarted");
			}
			else
			{
				throw new Exception("Header closed");
			}
			//should add trim on both params--later
		}
		public void HeaderEnd()
		{
			Console.Write("\r\n");
		}		
	};//class

	[TODO]
	public class HTMLFormatter
	{
		public static void PageStart(String title, Dictionary attrs)
		{
			Console.WriteLine("<HTML><HEAD><TITLE>");
			Console.WriteLine(title);
			Console.Write("</TITLE></HEAD><BODY ");
			if(attrs!=null)
			{
				ArrayList keys=attrs.Keys();
				ArrayList vals=attrs.Values();
				for(int i=1;i<attrs.Count;i++)
				{
					Console.Write(keys[i]+" = \""+vals[i]+"\" ");
				}
			}
			Console.WriteLine(">");
		}
		public static void A(String url,String link)
		{
			Console.WriteLine("<A HREF=\""+url+"\">");
			Console.WriteLine(link);
			Console.WriteLine("</A>");
		}
		public static void H1(String text, Dictionary attrs)
		{
			if(attrs==null)Console.WriteLine("<H1>"+text+"</H1>");
			else
			{
				Console.Write("<H1 ");
				ArrayList keys=attrs.Keys();
				ArrayList vals=attrs.Values();
				for(int i=0;i<attrs.Count;i++)
				{
					Console.Write(keys[i]+" = \""+vals[i]+"\" ");
				}
				Console.WriteLine(">"+text+"</H1>");
			}			
		}
		public static void TableStart(Dictionary attrs) 
		{
		}
		public static void TableEnd(Dictionary attrs)
		{
		}
		public static void PageEnd()
		{
			Console.WriteLine("</BODY></HTML>");
		}
	}

/***********************************************************************
                       MY CGI class !
************************************************************************/
	public class Pnetcgi
	{
		private WebRequest req;
		private WebResponse resp;
		private void run()
		{
			req = new WebRequest ();
			req.ReadRequest ();
			resp=new WebResponse();
			resp.SetRequest(req);
			resp.HeaderStart();
			resp.Header("Content-Type","text/html");
			resp.HeaderEnd();
			if((req.QueryParsed.Count >0) && (req.QueryParsed.Contains("add")) && (req.QueryParsed.Contains("int1")) && (req.QueryParsed.Contains("int2"))) 
			{
				PrintHeader();
				//Int16 i1=Int16.Parse((String)req.QueryParsed["int2"]);
				//Int16 i2=Int16.Parse((String)req.QueryParsed["int2"]);
				Console.Write(req.QueryParsed["int1"]+" + "+req.QueryParsed["int2"]+" = cannot add");
				PrintFooter();
			}
			else PrintInfo();			
		}
		/*
		 * I thought about implementing an HTMLFormatter class
		 * but has left it half done, to speed up the work at
		 * hand. Handling plain HTML is easier :-)
		 * lazy R US....
		 */
		 private void PrintHeader()
		 {
			Console.WriteLine("<HTML><HEAD><TITLE>");
			Console.WriteLine("<TITLE> Pnetcgi DEMO </TITLE>");
			Console.WriteLine("<BODY BGCOLOR=\"#dedebb\" TEXT=\"#00000\">");	
			Console.WriteLine("<P ALIGN=\"center\"><IMG SRC=\"/logo.png\"></P>");
		}
		private void PrintFooter()
		{
			Console.WriteLine("</BODY></HTML>");
		}
		private void PrintInfo()
		{
			Console.WriteLine("<HTML><HEAD><TITLE>");
			Console.WriteLine("<TITLE> Pnetcgi DEMO </TITLE>");
			Console.WriteLine("<BODY BGCOLOR=\"#dedebb\" TEXT=\"#00000\">");
			Console.WriteLine("<P ALIGN=\"center\"><IMG SRC=\"/logo.png\"></P>");
			Console.WriteLine("<H1 ALIGN=\"CENTER\">CGI Demo</H1>");
			Console.WriteLine("<H3 ALIGN=\"center\">Environment Variables</H3>");
			Console.WriteLine("<TABLE WIDTH=\"80%\" ALIGN=\"CENTER\" BORDER=\"1\" BORDERCOLOR=\"#CECEAA\">");
			
			Console.WriteLine("<TR><TH>Name</TH><TH>Value</TH></TR>");
			
			IDictionaryEnumerator e = req.EnvVars.GetEnumerator();
			while(e.MoveNext())
			{
				Console.Write("<TR><TD>");
				Console.Write((String)(e.Key));
				Console.Write("</TD><TD>");
				Console.Write((String)(e.Value));
				Console.WriteLine("</TD></TR>");
			}
			Console.WriteLine("</TABLE>");
			if(req.QueryParsed.Count > 0)
			{
				PrintQuery();
			}
			PrintAdd();
			PrintFooter();
		}
		private void PrintAdd()
		{
			Console.Write("<FORM METHOD=\"GET\">");
			Console.Write("<h3 align=\"center\"> ADD Demo</h3>");
			Console.Write("<TABLE BORDER=\"1\" BORDERCOLOR=\"CECEAA\" align=\"Center\">");
			Console.Write("<tr><td><INPUT TYPE=\"text\" name=\"int1\"></td>");
			Console.Write("<td><input type=\"submit\" value=\"  +  \"></td>");
			Console.Write("<td><INPUT TYPE=\"text\" name=\"int2\"></td></tr>");
			Console.Write("</table>");
			Console.Write("<INPUT TYPE=\"hidden\" name=\"add\" value=\"true\">");
			Console.Write("</FORM></p>");
		}
		private void PrintQuery()
		{
			Console.WriteLine("<H2 ALIGN=\"center\">");
			Console.WriteLine("Parsed Query </H2>");
			Console.WriteLine("<TABLE WIDTH=\"80%\" ALIGN=\"CENTER\" BORDER=\"1\" BORDERCOLOR=\"#CECEAA\">");
			
			Console.WriteLine("<TR><TH>Name</TH><TH>Value</TH></TR>");
			for(int i=0;i<req.QueryParsed.Count;i++)
			{
				Console.Write("<TR><TD>");
				Console.Write(req.QueryParsed.Keys()[i]);
				Console.Write("</TD><TD>");
				Console.Write(req.QueryParsed.Values()[i]);
				Console.WriteLine("</TD></TR>");
			}
			Console.WriteLine("</TABLE>");
		}
		public static void Main ()
		{
			Pnetcgi x=new Pnetcgi();
			x.run();
		}
	};//class
};//namespace
